/* audiod.cmdline.h */

/* File autogenerated by gengetopt version 2.17rc2  */

#ifndef AUDIOD_CMDLINE_H
#define AUDIOD_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef AUDIOD_CMDLINE_PARSER_PACKAGE
#define AUDIOD_CMDLINE_PARSER_PACKAGE "para_audiod"
#endif

#ifndef AUDIOD_CMDLINE_PARSER_VERSION
#define AUDIOD_CMDLINE_PARSER_VERSION "(paraslash 0.2.13, sonic convolution)\nCopyright (c) 1997-2006 by Andre Noll\nThis is free software with ABSOLUTELY NO WARRANTY. See COPYING for details."
#endif

struct audiod_args_info
{
  const char *help_help; /* Print help and exit help description.  */
  const char *version_help; /* Print version and exit help description.  */
  char * user_arg;	/* run as user 'name'. Read the output of
  'para_server -h' for more information on this
  option..  */
  char * user_orig;	/* run as user 'name'. Read the output of
  'para_server -h' for more information on this
  option. original value given at command line.  */
  const char *user_help; /* run as user 'name'. Read the output of
  'para_server -h' for more information on this
  option. help description.  */
  char * group_arg;	/* set group id to 'group'. Read the output of
  'para_server -h' for more information on this
  option..  */
  char * group_orig;	/* set group id to 'group'. Read the output of
  'para_server -h' for more information on this
  option. original value given at command line.  */
  const char *group_help; /* set group id to 'group'. Read the output of
  'para_server -h' for more information on this
  option. help description.  */
  int loglevel_arg;	/* set loglevel (0-6) (default='4').  */
  char * loglevel_orig;	/* set loglevel (0-6) original value given at command line.  */
  const char *loglevel_help; /* set loglevel (0-6) help description.  */
  int daemon_flag;	/* run as background daemon (default=off).  */
  const char *daemon_help; /* run as background daemon help description.  */
  int force_flag;	/* force startup even if
  socket exists (default=off).  */
  const char *force_help; /* force startup even if
  socket exists help description.  */
  char * logfile_arg;	/* (default=stdout/stderr).  */
  char * logfile_orig;	/* (default=stdout/stderr) original value given at command line.  */
  const char *logfile_help; /* (default=stdout/stderr) help description.  */
  char * mode_arg;	/* mode to use on startup (on/off/sb) (default='on').  */
  char * mode_orig;	/* mode to use on startup (on/off/sb) original value given at command line.  */
  const char *mode_help; /* mode to use on startup (on/off/sb) help description.  */
  char * socket_arg;	/* well-known socket to listen on
  (default=/var/paraslash/audiod_sock.<host_name>).  */
  char * socket_orig;	/* well-known socket to listen on
  (default=/var/paraslash/audiod_sock.<host_name>) original value given at command line.  */
  const char *socket_help; /* well-known socket to listen on
  (default=/var/paraslash/audiod_sock.<host_name>) help description.  */
  int* user_allow_arg;	/* allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, all users are allowed to
  connect. (default='-1').  */
  char ** user_allow_orig;	/* allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, all users are allowed to
  connect. original value given at command line.  */
  int user_allow_min; /* allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, all users are allowed to
  connect.'s minimum occurreces */
  int user_allow_max; /* allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, all users are allowed to
  connect.'s maximum occurreces */
  const char *user_allow_help; /* allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, all users are allowed to
  connect. help description.  */
  char ** receiver_arg;	/* Select receiver.  May be given multiple
  times, once for each supported audio format.
  'receiver_spec' consists of an audio format and
  the receiver name, separated by a colon, and
  any options for that receiver, seperated by
  whitespace.  If any receiver options are
  present, the whole receiver argument must be
  quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
 (default='http').  */
  char ** receiver_orig;	/* Select receiver.  May be given multiple
  times, once for each supported audio format.
  'receiver_spec' consists of an audio format and
  the receiver name, separated by a colon, and
  any options for that receiver, seperated by
  whitespace.  If any receiver options are
  present, the whole receiver argument must be
  quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
 original value given at command line.  */
  int receiver_min; /* Select receiver.  May be given multiple
  times, once for each supported audio format.
  'receiver_spec' consists of an audio format and
  the receiver name, separated by a colon, and
  any options for that receiver, seperated by
  whitespace.  If any receiver options are
  present, the whole receiver argument must be
  quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
's minimum occurreces */
  int receiver_max; /* Select receiver.  May be given multiple
  times, once for each supported audio format.
  'receiver_spec' consists of an audio format and
  the receiver name, separated by a colon, and
  any options for that receiver, seperated by
  whitespace.  If any receiver options are
  present, the whole receiver argument must be
  quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
's maximum occurreces */
  const char *receiver_help; /* Select receiver.  May be given multiple
  times, once for each supported audio format.
  'receiver_spec' consists of an audio format and
  the receiver name, separated by a colon, and
  any options for that receiver, seperated by
  whitespace.  If any receiver options are
  present, the whole receiver argument must be
  quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
 help description.  */
  int no_default_filters_flag;	/* Configure filters manually. If (and only
  if) this option is set, the --filter options
  take effect.  Otherwise, the compiled-in
  default filters mp3dec (oggdec) and wav are
  activated for mp3 (ogg) streams. (default=off).  */
  const char *no_default_filters_help; /* Configure filters manually. If (and only
  if) this option is set, the --filter options
  take effect.  Otherwise, the compiled-in
  default filters mp3dec (oggdec) and wav are
  activated for mp3 (ogg) streams. help description.  */
  char ** filter_arg;	/* Select filter(s) manually.  May be given
  multiple times. filter_spec consists of an
  audio format, the name of the filter, and any
  options for that filter.
  
  Examples:
  	-f 'mp3:mp3dec'
  	-f 'mp3:compress --inertia 5 --damp 2'
  
  Note that these options are ignored by default,
  see --no_default_filters..  */
  char ** filter_orig;	/* Select filter(s) manually.  May be given
  multiple times. filter_spec consists of an
  audio format, the name of the filter, and any
  options for that filter.
  
  Examples:
  	-f 'mp3:mp3dec'
  	-f 'mp3:compress --inertia 5 --damp 2'
  
  Note that these options are ignored by default,
  see --no_default_filters. original value given at command line.  */
  int filter_min; /* Select filter(s) manually.  May be given
  multiple times. filter_spec consists of an
  audio format, the name of the filter, and any
  options for that filter.
  
  Examples:
  	-f 'mp3:mp3dec'
  	-f 'mp3:compress --inertia 5 --damp 2'
  
  Note that these options are ignored by default,
  see --no_default_filters.'s minimum occurreces */
  int filter_max; /* Select filter(s) manually.  May be given
  multiple times. filter_spec consists of an
  audio format, the name of the filter, and any
  options for that filter.
  
  Examples:
  	-f 'mp3:mp3dec'
  	-f 'mp3:compress --inertia 5 --damp 2'
  
  Note that these options are ignored by default,
  see --no_default_filters.'s maximum occurreces */
  const char *filter_help; /* Select filter(s) manually.  May be given
  multiple times. filter_spec consists of an
  audio format, the name of the filter, and any
  options for that filter.
  
  Examples:
  	-f 'mp3:mp3dec'
  	-f 'mp3:compress --inertia 5 --damp 2'
  
  Note that these options are ignored by default,
  see --no_default_filters. help description.  */
  char ** writer_arg;	/* Specify stream writer.
  
  May be given multiple times, even multiple
  times for the same audio format.  Default
  value is 'alsa' for all supported audio
  formats. Example:
  
  	-w 'aac:osx'
  
.  */
  char ** writer_orig;	/* Specify stream writer.
  
  May be given multiple times, even multiple
  times for the same audio format.  Default
  value is 'alsa' for all supported audio
  formats. Example:
  
  	-w 'aac:osx'
  
 original value given at command line.  */
  int writer_min; /* Specify stream writer.
  
  May be given multiple times, even multiple
  times for the same audio format.  Default
  value is 'alsa' for all supported audio
  formats. Example:
  
  	-w 'aac:osx'
  
's minimum occurreces */
  int writer_max; /* Specify stream writer.
  
  May be given multiple times, even multiple
  times for the same audio format.  Default
  value is 'alsa' for all supported audio
  formats. Example:
  
  	-w 'aac:osx'
  
's maximum occurreces */
  const char *writer_help; /* Specify stream writer.
  
  May be given multiple times, even multiple
  times for the same audio format.  Default
  value is 'alsa' for all supported audio
  formats. Example:
  
  	-w 'aac:osx'
  
 help description.  */
  int stream_delay_arg;	/* Time to add to para_server's start_time.
  
  Amount of time to be added to the server, before data is sent to
  the writer.  Useful for syncronizing the audio output of clients. (default='200').  */
  char * stream_delay_orig;	/* Time to add to para_server's start_time.
  
  Amount of time to be added to the server, before data is sent to
  the writer.  Useful for syncronizing the audio output of clients. original value given at command line.  */
  const char *stream_delay_help; /* Time to add to para_server's start_time.
  
  Amount of time to be added to the server, before data is sent to
  the writer.  Useful for syncronizing the audio output of clients. help description.  */
  int stream_timeout_arg;	/* Deactivate slot if idle for that many
  seconds (default='30').  */
  char * stream_timeout_orig;	/* Deactivate slot if idle for that many
  seconds original value given at command line.  */
  const char *stream_timeout_help; /* Deactivate slot if idle for that many
  seconds help description.  */
  
  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int user_given ;	/* Whether user was given.  */
  int group_given ;	/* Whether group was given.  */
  int loglevel_given ;	/* Whether loglevel was given.  */
  int daemon_given ;	/* Whether daemon was given.  */
  int force_given ;	/* Whether force was given.  */
  int logfile_given ;	/* Whether logfile was given.  */
  int mode_given ;	/* Whether mode was given.  */
  int socket_given ;	/* Whether socket was given.  */
  unsigned int user_allow_given ;	/* Whether user_allow was given.  */
  unsigned int receiver_given ;	/* Whether receiver was given.  */
  int no_default_filters_given ;	/* Whether no_default_filters was given.  */
  unsigned int filter_given ;	/* Whether filter was given.  */
  unsigned int writer_given ;	/* Whether writer was given.  */
  int stream_delay_given ;	/* Whether stream_delay was given.  */
  int stream_timeout_given ;	/* Whether stream_timeout was given.  */

} ;

extern const char *audiod_args_info_purpose;
extern const char *audiod_args_info_usage;
extern const char *audiod_args_info_help[];

int audiod_cmdline_parser (int argc, char * const *argv,
  struct audiod_args_info *args_info);
int audiod_cmdline_parser2 (int argc, char * const *argv,
  struct audiod_args_info *args_info,
  int override, int initialize, int check_required);
int audiod_cmdline_parser_file_save(const char *filename,
  struct audiod_args_info *args_info);

void audiod_cmdline_parser_print_help(void);
void audiod_cmdline_parser_print_version(void);

void audiod_cmdline_parser_init (struct audiod_args_info *args_info);
void audiod_cmdline_parser_free (struct audiod_args_info *args_info);

int audiod_cmdline_parser_configfile (char * const filename,
  struct audiod_args_info *args_info,
  int override, int initialize, int check_required);

int audiod_cmdline_parser_required (struct audiod_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* AUDIOD_CMDLINE_H */
